using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using InstrumentDrivers;

namespace RSSMU_CDMA2000_Example
{
    public partial class RSSMU_CDMA2000_Example : Form
    {
        private rssmu m_Instrument = null;
        public RSSMU_CDMA2000_Example()
        {
            InitializeComponent();
        }

        private void RSSMU_CDMA2000_Example_Load(object sender, EventArgs e)
        {
            RadioConf.SelectedIndex = 0;
            DataRate.SelectedIndex = 0;
            CrestFactor.SelectedIndex = 0;
        }

        private void ExitButton_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Are you sure you want to exit?", "Exit?", MessageBoxButtons.YesNo) == DialogResult.Yes)
                Close();
        }

        private void Apply_Click(object sender, EventArgs e)
        {
            int path = 1;
            try
            {
                UseWaitCursor = true;
                System.Windows.Forms.Cursor.Current = Cursors.WaitCursor;
                if (m_Instrument==null)
                    m_Instrument = new rssmu(ResourceDescriptor.Text, IDQuery.Checked, ResetDevice.Checked);
                m_Instrument.SetC2kPredefinedRadioConfigurationBS(path, RadioConf.SelectedIndex + 1);
                m_Instrument.SetC2kUsePilotFPICHBS(path, UsePilot.Checked);
                m_Instrument.SetC2kUseSYNCFSYNCBS(path, UseSync.Checked);
                m_Instrument.SetC2kUsePagingChannelFPCHBS(path, UsePaging.Checked);

                m_Instrument.SetC2kNumberOfTrafficChannelsBS(path, int.Parse(NumTch.Text));

                if (RadioConf.SelectedIndex > 1)
                    m_Instrument.SetC2kUseDedicatedControlFDCCHBS(path, UseDedic.Checked);

                m_Instrument.SetC2kUseFundamentalFFCHBS(path, UseFund.Checked);
                m_Instrument.SetC2kNumberOfSupplementalFSCHBS(path, int.Parse(NumSup.Text));
                m_Instrument.SetC2kPredefinedFrameLengthBS(path, int.Parse(FrameLength.Text));
                m_Instrument.SetC2kPredefinedDataRateBS(path, DataRate.SelectedIndex);

                m_Instrument.SetC2kCrestFactorBS(path, CrestFactor.SelectedIndex);
                m_Instrument.SetC2kSequenceLengthARB(path, int.Parse(SequenceLength.Text));
                m_Instrument.SetC2kInvertQforCorrectBasebandOutput(path, InvertQ.Checked);
                m_Instrument.SetC2kState(path, CDMAState.Checked);

                m_Instrument.SetRFAmplitude(path, Decimal.ToDouble(RFLevel.Value));
                m_Instrument.SetRFFrequency(path, Decimal.ToDouble(RFFreq.Value));
                m_Instrument.SetOutputState(path, RFState.Checked);
            }
            catch (Exception ex)
            {
                String message;

                message = "Instrument Status Error: ";
                message += ex.Message;
                MessageBox.Show(message);
            }
            System.Windows.Forms.Cursor.Current = Cursors.Arrow;
            UseWaitCursor = false;

        }
    }
}